with Ada.Text_IO;
with Generic_Stacks;

procedure Main is
   package Integer_Stacks_Pkg is new Generic_Stacks (100, Integer);
   use Integer_Stacks_Pkg;
   subtype Integer_Stack is Integer_Stacks_Pkg.Stack;
   S : Integer_Stack;

   type Array_Of_Integer is array (Positive range <>) of Integer;
begin

   Ada.TexT_IO.Put_Line (S'Image);

   for I of Array_Of_Integer'(1, 2, 3, 4) loop
      Push (S, I);
   end loop;

   Ada.Text_IO.Put_Line (S'Image);

   while not Empty (S) loop
      declare
         I : constant Integer := Pop (S);
      begin
         Ada.Text_IO.Put_Line (I'Image);
      end;
   end loop;

   Ada.Text_IO.Put_Line (S'Image);

end Main;
